// ObserverSwarm.m

#import "ObserverSwarm.h"
#import <activity.h>
#import <simtoolsgui.h>

@implementation ObserverSwarm

+ createBegin: aZone
{
  ObserverSwarm *obj;
  id <ProbeMap> probeMap;

  obj = [super createBegin: aZone];
  obj->displayFrequency          = 1;

  probeMap = [EmptyProbeMap createBegin: aZone];
  [probeMap setProbedClass: [self class]];
  probeMap = [probeMap createEnd];

  [probeMap addProbe: [probeLibrary getProbeForVariable: 
            "displayFrequency"    inClass: [self class]]];

  [probeLibrary setProbeMap: probeMap For: [self class]];

  return obj;
}

- createEnd
{
  return [super createEnd];
}


- buildObjects
{
  [super buildObjects];

  ops = [Ops create: self];

  CREATE_ARCHIVED_PROBE_DISPLAY (self);

  [controlPanel setStateStopped];

  [ops drop];

  return self;
}

- buildActions
{
  [super buildActions];

   displayActions = [ActionGroup create: self];

  [displayActions createActionTo: probeDisplayManager message: M(update)];
  [displayActions createActionTo: actionCache message: M(doTkEvents)];

  displaySchedule = [Schedule createBegin: self];
  [displaySchedule setRepeatInterval: displayFrequency];
  displaySchedule = [displaySchedule createEnd];

  [displaySchedule at: 0 createAction: displayActions];

  return self;
}

- activateIn: swarmContext
{
  [super activateIn: swarmContext];

  [displaySchedule activateIn: self];

  return [self getSwarmActivity];
}

@end


